part of plot_window;

class PointList {

  List<Point> cropToRange(Range range)=>this._points.skipWhile((Point p)=>p.x<range.start).takeWhile((Point p)=>p.x<=range.end);

  Range _lrRange;
  Range get lrRange => _lrRange??=new Range(points.first.x, points.last.x);

  void clearlr() {
    _lrRange = null;
    _linearRegression = null;
  }
  
  void set range(Range range) {
    if (range==null) return clearlr();
    var newPoints = cropToRange(range);
    if (newPoints.isEmpty) return clearlr();
    var newRange = new Range(newPoints.first.x, newPoints.last.x);
    if (newRange != lrRange) {
      _lrRange = newRange;
      _lrPoints = newPoints;
      _linearRegression = null;
      //      _linearRegression=new LinearRegression(newPoints, lrFormat);
    }
  }

  String lrFormat;
  
  List<Point> _points;
  List<Point> get points=>_points;

  List<Point> _lrPoints;

  List<Point> get lrPoints => _lrPoints ?? points;
  
  Point get first => points.first;
  Point get last => points.last;
  
  LinearRegression _linearRegression;
  LinearRegression get linearRegression => _linearRegression ??= new LinearRegression(lrPoints, lrFormat);
  
  bool cropLinearRegression = false;
  Range pickRange(Range fixedRange, Range cropRange) => cropLinearRegression? cropRange: fixedRange;
  
  PointList(List<Point> p) {
    this._points = new List.from(p, growable:false);
    this._points.sort((Point p1, Point p2)=>p1.x-p2.x);
  }

  /*
  PointList smooth(PointSmoother smoother) {
    return new PointList(smoother.smooth(points));
  }
  */
}

